#include <sourcemod>
#pragma semicolon 1

public Plugin:myinfo = 
{
	name = "Health penalty",
	author = "Figa",
	description = "Penalty health for suicide",
	version = "1.0",
	url = "http://www.fiksiki.3dn.ru/"
};

//new Handle: SuicideCheck[MAXPLAYERS + 1];
new bool: SuicideCheck[MAXPLAYERS + 1];
new Handle: PenaltyHealth;

public OnPluginStart()
{
	PenaltyHealth = CreateConVar("hp_penalty", "10", "How much to give penalty HP player in the early rounds.", FCVAR_PLUGIN);
	
	HookEvent("map_transition", map_transition, EventHookMode_Pre);
	HookEvent("finale_win", finale_win, EventHookMode_Pre);
	HookEvent("round_start", round_start);
}

public Action:map_transition(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new i=1; i<=MaxClients; i++)
	{
		if (IsClientInGame(i) && GetClientTeam(i) == 2)
		{
			if (!IsPlayerAlive(i)) SuicideCheck[i] = true;
			if (IsPlayerAlive(i)) SuicideCheck[i] = false;
		}
	}
}

public Action:finale_win(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new i=1; i<=MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i) && SuicideCheck[i])
		{
			SuicideCheck[i] = false;
		}
	}
}

public Action:round_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new i=1; i<=MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i) && SuicideCheck[i])
		{
			CreateTimer(0.1, GivePenaltyHealth, i);
		}
	}
}

public OnClientPutInServer(client)
{
	if (IsFakeClient(client) || (!client))
	{
		return;
	}
	if (SuicideCheck[client])
	{
		CreateTimer(1.0, GivePenaltyHealth, client);
	}
}

public Action:GivePenaltyHealth(Handle:timer, any:client)
{
	SetEntProp(client, Prop_Send, "m_iHealth", GetConVarInt(PenaltyHealth));
	//PrintToServer("SuicideCheck Client");
}